<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\MAN\Services;

class ManutencaoVenda extends \Teknisa\MAN\Controllers\TeknisaCrud {
    
    protected $dataSourceRecebimentos = 'select_recebimentos';
	protected $dataSourceName = 'vnd02600_manutencaodavenda';
	protected $entityManager;
	protected $crudService;
    protected $novoCodigo;
    protected $ManutencaoVendaService;
    protected $MovCaixaBD;
    protected $util;
    

    public function __construct ($crudService,$entityManager, $novoCodigo,$ManutencaoVendaService,  $MovCaixaBD, $util) {
        $this->crudService            = $crudService;
		$this->entityManager          = $entityManager;
        $this->novoCodigo             = $novoCodigo;
        $this->ManutencaoVendaService = $ManutencaoVendaService;
        $this->MovCaixaBD             = $MovCaixaBD; 
        $this->util                   = $util;
    }
    
    public function findRecebimentos(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceRecebimentos;
        parent::find($request, $response);    
    }

    public function savePedingSale (DTO\Request $request, DTO\Response $response){
        try {
            $row = $request->getRow();
            $pedido = 'PEDIDOVENDA'.$row['CDFILIAL'].$row['CDCAIXA'];
            $row['NRSEQVENDA'] = $this->novoCodigo->getCodeByTableName($pedido, '1');
            $CDFILIAL       = $row['CDFILIAL'];
            $CDCAIXA        = $row['CDCAIXA'];
            $CDCLIENTE      = $row['CDCLIENTE'];
            $CDCONSUMIDOR   = $row['CDCONSUMIDOR'];
            $CDSERVFILI     = $row['CDSERVFILI'];
            $CDVENDEDOR     = $row['CDVENDEDOR'];
            $DTABERTUR      = $row['DTABERTUR'];
            $DTENTRVENDA    = $row['DTENTRVENDA'];
            $DTVENDA        = $row['DTENTRVENDA']." ".$row['HRVENDA'];
            $IDORIGEMVENDA  = $row['IDORIGEMVENDA'];
            $IDSITUVENDA    = $row['IDSITUVENDA'];
            $IDTIPOVENDA    = $row['IDTIPOVENDA'];
            $IDTPEMISVEND   = $row['IDTPEMISVEND'];
            $NRCUPOMFIS     = $row['NRCUPOMFIS'];
            $NRSEQVENDA     = $row['NRSEQVENDA'];
            $NRORDEMVND     = $row['NRORDEMVND'];
            $NRSERIEIMPVND  = $row['NRSERIEIMPVND'];
            $NRSERIEVND     = $row['NRSERIEVND'];
            $NRSUBSERIEVND  = $row['NRSUBSERIEVND'];
            $NRORG          = $row['NRORG'];
            $CDEMPRESA      = $this->ManutencaoVendaService->getEmpresa($CDFILIAL, $NRORG);
            $CDLOJA         = $this->ManutencaoVendaService->getLoja($CDFILIAL, $CDCAIXA, $NRORG);
            $CDOPERADOR     = $row['CDOPERADOR'];

            //$CDCCUSCLIE
            //$TXOBSVENDA = "Venda Incluida manualmente pelo Manage! Em :";
            try {
                $this->ManutencaoVendaService->savePedingSale($CDFILIAL, $CDCAIXA, $CDCLIENTE, $CDCONSUMIDOR, $CDSERVFILI, $CDVENDEDOR, $DTABERTUR, $DTENTRVENDA, $DTVENDA, $IDORIGEMVENDA, $IDSITUVENDA, $IDTIPOVENDA, $IDTPEMISVEND, $NRCUPOMFIS, $NRSEQVENDA, $NRORDEMVND, $NRSERIEIMPVND, $NRSERIEVND, $NRSUBSERIEVND, $CDEMPRESA, $CDLOJA, $CDOPERADOR, $NRORG);
                
            } catch (Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
            }
        
            $response->addNotification(new Notification("Venda Incluida Com Sucesso!", Notification::TYPE_SUCCESS));

        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function saveItem (DTO\Request $request, DTO\Response $response){
        try {
            $row = $request->getRow();
            //item
            $CDFILIAL       = $row['CDFILIAL'];
            $CDCAIXA        = $row['CDCAIXA'];
            $NRSEQVENDA     = $row['NRSEQVENDA'];
            $NRSEQUITVEND   = $row['is_new'] ? $this->ManutencaoVendaService->getSeqItem($NRSEQVENDA, $CDFILIAL, $CDCAIXA) : $row['NRSEQUITVEND'];
            $QTPRODVEND     = (float)str_replace(',', '.',$row['QTPRODVEND']);
            $VRUNITVEND     = (float)str_replace(',', '.', $row['VRUNITVEND']);
            $VRDESITVEND    = $row['VRDESITVEND'] == '.' ? 0 : $row['VRDESITVEND'] ;
            $VRPERCVEND     = $row['VRPERCVEND'] == '.' ? 0 : $row['VRPERCVEND'];
            $VRACRITVEND    = $row['VRACRITVEND'] == '.' ? 0 : $row['VRACRITVEND'];
            $VRUNITVENDCL   = $row['VRUNITVENDCL'] == '.' ? 0 : $row['VRUNITVENDCL'];
            $CDSUBGRPROD    = $row['is_new'] ? null : $row['CDSUBGRPROD'];
            $CDGRUPPROD     = $row['is_new'] ? null : $row['CDGRUPPROD'];
            $CDFISUBGRVND   = $row['is_new'] ? null : $row['CDFISUBGRVND'];
            $CDPRODUTO      = $row['CDPRODUTO'];
            $NRORG          = $row['NRORG'];
            $CDOPERINCLUSAO = $row['CDOPERINCLUSAO'];
            //imposto
            $NRSEQITIMPOS   = '001';
            $CDIMPOSTO      = $row['CDIMPOSTO'];
            $VRPEALPRODIT   = str_replace(',', '.', str_replace('.', '', $row['VRPEALPRODIT']));
            $VRIMPOPRODIT   = (floatval($row['QTPRODVEND']) * floatval($row['VRUNITVEND']))* ((floatval($row['VRPEALPRODIT'])/100));
            $CDIMPOSTOEX    = $row['CDIMPOSTOEX'];
            
            try {
                if($row['is_new']){
                    $this->ManutencaoVendaService->saveItem($CDFILIAL, $CDCAIXA, $NRSEQVENDA, $NRSEQUITVEND, $QTPRODVEND, $VRUNITVEND, $VRDESITVEND, $VRPERCVEND, $CDPRODUTO, $VRUNITVENDCL, $VRACRITVEND, $NRORG, $CDOPERINCLUSAO);
                    $this->ManutencaoVendaService->saveImpoItem($CDFILIAL, $CDCAIXA, $NRSEQVENDA, $NRSEQUITVEND, $NRSEQITIMPOS, $CDIMPOSTO, $VRPEALPRODIT, $VRIMPOPRODIT, $CDIMPOSTOEX, $NRORG, $CDOPERINCLUSAO);
                    $response->addNotification(new Notification("Item Incluido com Sucesso!", Notification::TYPE_SUCCESS));
                } else {
                    $this->ManutencaoVendaService->updateItem($CDFILIAL, $CDCAIXA, $NRSEQVENDA, $NRSEQUITVEND, $QTPRODVEND, $VRUNITVEND, $VRDESITVEND, $VRPERCVEND, $CDPRODUTO, $VRUNITVENDCL, $VRACRITVEND, $NRORG, $CDOPERINCLUSAO, $CDSUBGRPROD, $CDGRUPPROD, $CDFISUBGRVND);
                    $this->ManutencaoVendaService->updateImpoItem($CDFILIAL, $CDCAIXA, $NRSEQVENDA, $NRSEQUITVEND, $NRSEQITIMPOS, $CDIMPOSTO, $VRPEALPRODIT, $VRIMPOPRODIT, $CDIMPOSTOEX, $NRORG, $CDOPERINCLUSAO);
                    $response->addNotification(new Notification("Item Editado com Sucesso!", Notification::TYPE_SUCCESS));
                }
                
            } catch (Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
            }
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function saveItemCan (DTO\Request $request, DTO\Response $response){
        try {
            $row = $request->getRow();
            $VRPERCVENDC    = str_replace(',', '.', str_replace('.', '', $row['VRPERCVENDC']));
            $VRUNITVENDC    = str_replace(',', '.', str_replace('.', '', $row['VRUNITVENDC']));
            $VRUNITVENCLC   = $row['VRUNITVENCLC'] == null ? 0 : str_replace(',', '.', str_replace('.', '', $row['VRUNITVENCLC']));
            $VRACRITVENDC   = $row['VRACRITVENDC'] == null ? 0 : str_replace(',', '.', str_replace('.', '', $row['VRACRITVENDC']));
            
            $CDFILIAL       = $row['CDFILIAL'];
            $CDCAIXA        = $row['CDCAIXA'];
            $NRSEQVENDA     = $row['NRSEQVENDA'];
            $NRSEQITVENDC   = $row['is_new'] ? $this->ManutencaoVendaService->getSeqItemCan($NRSEQVENDA, $CDFILIAL, $CDCAIXA) : $row['NRSEQITVENDC'];
            $QTPRODVENDC    = (float)str_replace(',', '.',$row['QTPRODVENDC']);
            $VRDESITVENDC   = $row['VRDESITVENDC'] ? $row['VRDESITVENDC'] : 0 ;
            $CDPRODUTO      = $row['CDPRODUTO'];
            $NRORG          = $row['NRORG'];
            $CDOPERINCLUSAO = $row['CDOPERINCLUSAO'];
            $CDSUBGRPROD    = $row['is_new'] ? null : $row['CDSUBGRPROD'];
            $CDGRUPPROD     = $row['is_new'] ? null : $row['CDGRUPPROD'];
            $CDFISUBGRVNC   = $row['is_new'] ? null : $row['CDFISUBGRVNC'];
            
            try {
                if($row['is_new']){
                    $this->ManutencaoVendaService->saveItemCancelado($CDFILIAL, $CDCAIXA, $NRSEQVENDA, $NRSEQITVENDC, $QTPRODVENDC, $VRUNITVENDC, $VRDESITVENDC, $VRPERCVENDC, $CDPRODUTO, $VRUNITVENCLC, $VRACRITVENDC, $NRORG, $CDOPERINCLUSAO);
                    $response->addNotification(new Notification("Item cancelado Incluido com Sucesso!", Notification::TYPE_SUCCESS));
                } else {
                    $this->ManutencaoVendaService->updateItemCancelado($CDFILIAL, $CDCAIXA, $NRSEQVENDA, $NRSEQITVENDC, $QTPRODVENDC, $VRUNITVENDC, $VRDESITVENDC, $VRPERCVENDC, $CDPRODUTO, $VRUNITVENCLC, $VRACRITVENDC, $NRORG, $CDOPERINCLUSAO, $CDSUBGRPROD, $CDGRUPPROD, $CDFISUBGRVNC);
                    $response->addNotification(new Notification("Item cancelado Editado com Sucesso!", Notification::TYPE_SUCCESS));
                }
            } catch (Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));    
            }

        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function savePayment (DTO\Request $request, DTO\Response $response){
        
        
        try {
            $row = $request->getRow();
            $QTPARCRECEB = (string)$row['QTPARCRECEB'];
            $NRORG = (string)$row['NRORG'];
            
            $paramToNRSEQUMOVI = array(
                    ':CDFILIAL'         => $row['CDFILIAL'],
                    ':CDCAIXA'          => $row['CDCAIXA'],
                    ':DTABERCAIX'       => $row['DTABERCAIX'],
                    ':NRORG'            => $NRORG
                    );
            $NRSEQUMOVI = $this->MovCaixaBD->buscaNRSEQUMOVI($paramToNRSEQUMOVI);
            $NRSEQUMOVI = str_pad($NRSEQUMOVI[0]['NRSEQUMOVI']+1, 10, "0", STR_PAD_LEFT);
            
            $paramToTotalVRMOVIVEND = array(
                    ':CDFILIAL'         => $row['CDFILIAL'],
                    ':CDCAIXA'          => $row['CDCAIXA'],
                    ':NRSEQVENDA'       => $row['NRSEQVENDA'],
                    ':NRORG'            => $NRORG
                    );
            $TOTALMOVIVND = $this->MovCaixaBD->buscaTotalVRMOVIVEND($paramToTotalVRMOVIVEND);
            $TOTALMOVIVND_RECE = $this->MovCaixaBD->buscaTotalRecebimentoVRMOVIVEND($paramToTotalVRMOVIVEND);
            $VRMOVIVEND = (float)str_replace(',', '.', $row['VRMOVIVEND']);
            $VRMOVIVENDBKP =  (float)str_replace(',', '.', $row['VRMOVIVENDBKP']);
            $STRTOTAL = str_replace('.', ',', $TOTALMOVIVND[0]['VRTOT']);
            if($TOTALMOVIVND[0]['VRTOT'] > ($TOTALMOVIVND_RECE[0]['MOVIVENDTOTAL'] + $VRMOVIVEND)){
                $response->addMessage(new Message("Atenção! Valor dos recebimentos difere do valor total da venda. <br>
                        Valor deve ser {$STRTOTAL}",Message::TYPE_WARNING));
            }
            
            $DTHRINCMOV = explode( " ", $row['DTMOVIMCAIXA'] );
            $params = array(
                ':CDFILIAL'         => $row['CDFILIAL'],
                ':CDCAIXA'          => $row['CDCAIXA'],
                ':CDTIPORECE'       => $row['CDTIPORECE'],
                ':VRMOVIVEND'       => $VRMOVIVEND,
                ':DTABERCAIX'       => $row['DTABERCAIX'],
                ':NRSEQUMOVI'       => $NRSEQUMOVI,
                ':NRSEQUMOVIBKP'    => $row['NRSEQUMOVIBKP'],
                ':VRCOTINDOUT'      => $row['is_new'] ? null : $row['VRCOTINDOUT'],
                ':IDTIPOMOVIVE'     => $row['IDTIPOMOVIVE'],
                ':NRSEQVENDA'       => $row['NRSEQVENDA'],
                ':DTMOVIMCAIXA'     => $row['DTMOVIMCAIXA'],
                ':VRMOVIVEOUT'      => $row['VRMOVIVEOUT'],
                ':DTHRINCMOV'       => $DTHRINCMOV[0],
                ':QTPARCRECEB'      => $QTPARCRECEB,
                ':NRORG'            => $NRORG,
                ':CDOPERINCLUSAO'   => $row['CDOPERINCLUSAO'],
                ':NRENVELOPE'       => null
            );
            try {
                if($row['is_new']){
                    if($TOTALMOVIVND[0]['VRTOT'] < ($TOTALMOVIVND_RECE[0]['MOVIVENDTOTAL'] + $VRMOVIVEND )){
                        $response->addMessage(new Message("Valor do recebimentos deve ser igual ao valor total da venda. <br>
                                Valor deve ser {$STRTOTAL}",Message::TYPE_ERROR));
                        return $response;
                    }
                    $this->MovCaixaBD->saveMovcaixa($params);
                    $response->addMessage(new Message("Recebimento Incluido com Sucesso!", Message::TYPE_MESSAGE));
                } else {
                    if($TOTALMOVIVND[0]['VRTOT'] < ($TOTALMOVIVND_RECE[0]['MOVIVENDTOTAL'] + $VRMOVIVEND - $VRMOVIVENDBKP )){
                        $response->addMessage(new Message("Valor do recebimentos deve ser igual ao valor total da venda. <br>
                                Valor deve ser {$STRTOTAL}",Message::TYPE_ERROR));
                        return $response;
                    }
                    $this->ManutencaoVendaService->updateItensRecebimento($params);
                    $response->addMessage(new Message("Recebimento Editado com Sucesso!", Message::TYPE_MESSAGE));
                }
            } catch (\Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));        
            }
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function closeSale (DTO\Request $request, DTO\Response $response){
        try {
            $row = $request->getRow();
            $CDFILIAL   = $row['CDFILIAL'];
            $CDCAIXA    = $row['CDCAIXA'];
            $NRSEQVENDA = $row['NRSEQVENDA'];
            $NRORG      = $row['NRORG'];
            
            $CHECK_SALE_VALUES = $this->ManutencaoVendaService->checkSaleValues($NRSEQVENDA, $CDFILIAL, $CDCAIXA, $NRORG);
            if($CHECK_SALE_VALUES == 2){
                try{
                    $this->ManutencaoVendaService->closeSale($NRSEQVENDA, $CDFILIAL, $CDCAIXA);
                } catch(Exception $e) {
                    $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));        
                }
                 $response->addNotification(new Notification("Venda concluida com Sucesso!", Notification::TYPE_SUCCESS));
            } else  if ($CHECK_SALE_VALUES == 1){
                $response->addNotification(new Notification("Operação Bloqueada. A venda não foi totalmente paga.", Notification::TYPE_ERROR));
            } else  if ($CHECK_SALE_VALUES == 0){
                $response->addNotification(new Notification("Operação Bloqueada. Não há itens na venda.", Notification::TYPE_ERROR));
            }  
            
        } catch (Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function cancelSale (DTO\Request $request, DTO\Response $response){
        try {
            $row = $request->getRow();
            $CDFILIAL   = $row['CDFILIAL'];
            $CDCAIXA    = $row['CDCAIXA'];
            $NRSEQVENDA = $row['NRSEQVENDA'];
            $NRORG      = $row['NRORG'];
            try{
                $this->ManutencaoVendaService->cancelMovcaixa($NRSEQVENDA, $CDFILIAL, $CDCAIXA, $NRORG);
                $this->ManutencaoVendaService->cancelSale($NRSEQVENDA, $CDFILIAL, $CDCAIXA, $NRORG);
            } catch(Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));        
            }

            $response->addNotification(new Notification("Venda cancelada com Sucesso!", Notification::TYPE_SUCCESS));
        } catch (Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function saveReducaoZ (DTO\Request $request, DTO\Response $response){
        $row = $request->getRow();
        $arr = array(
                ':CDOPERADOR'         => $row['CDOPERADOR'],
            );
        $opQuery = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_OPERADOR_BY_CDOPERADOR, $arr)[0]['NMOPERADOR'];
        $DTREDUCAOZ = (string)$row['DTREDUCAOZ'];
        $NRECFREDZ = (string)$row['NRECFREDZ'];
        $NRREINIREDZ = (string)$row['NRREINIREDZ'];
        $NRSERIEREDZ = (string)$row['NRSERIEREDZ'];
        $NRREDREDZ = (string)$row['NRREDREDZ'];
        $NRLEITREDZ = (string)$row['NRLEITREDZ'];
        $NRGERCNFREDZ = (string)$row['NRGERCNFREDZ'];
        $NRCANCFREDZ = (string)$row['NRCANCFREDZ'];
        $NRPRIMCFREDZ = (string)$row['NRPRIMCFREDZ'];
        $NRULTCFREDZ = (string)$row['NRULTCFREDZ'];
        $VRGTREDZ = str_replace(',', '.', str_replace('.', '', $row['VRGTREDZ']));
        $VRVENBRUREDZ = str_replace(',', '.', str_replace('.', '', $row['VRVENBRUREDZ']));
        $VRISSREDZ = str_replace(',', '.', str_replace('.', '', $row['VRISSREDZ']));
        $VRTOTCANREDZ = str_replace(',', '.', str_replace('.', '', $row['VRTOTCANREDZ']));
        $VRTOTDESREDZ = str_replace(',', '.', str_replace('.', '', $row['VRTOTDESREDZ']));
        $VRVENLIQREDZ = str_replace(',', '.', str_replace('.', '', $row['VRVENLIQREDZ']));
        $VRTOTACRREDZ = str_replace(',', '.', str_replace('.', '', $row['VRTOTACRREDZ']));
        $IDORIGEMREDZ = (string)$row['IDORIGEMREDZ'];
        $DSMODMARCAECF = (string)$row['DSMODMARCAECF'];
        $NRORG = (string)$row['NRORG'];
        $CDFILIAL = (string)$row['CDFILIAL'];
        $CDCAIXA = (string)$row['CDCAIXA'];
        $CDOPERADOR = (string)$row['CDOPERADOR'];
        $NMOPERADOR = (string)$opQuery;
        $VRSTRIBREDZ = str_replace(',', '.', str_replace('.', '', $row['VRSTRIBREDZ']));
        $VRISENCREDZ = str_replace(',', '.', str_replace('.', '', $row['VRISENCREDZ']));
        $VRNINCIDREDZ = str_replace(',', '.', str_replace('.', '', $row['VRNINCIDREDZ']));
        $QTTEMLIGREDZ = (string)$row['QTTEMLIGREDZ'];
        $QTTEMPCFREDZ = (string)$row['QTTEMPCFREDZ'];
        $QTMEMRESREDZ = (string)$row['QTMEMRESREDZ'];
        $NEW = $row['NEW'];
        
        if($NEW){
            $VERIFY = $this->ManutencaoVendaService->verifyReducaoZ($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA);
            if (empty($VERIFY)){
                $this->ManutencaoVendaService->saveReducaoZ($DTREDUCAOZ, $NRECFREDZ, $NRREINIREDZ, $NRSERIEREDZ, $NRREDREDZ, $NRLEITREDZ, $NRGERCNFREDZ, $NRCANCFREDZ, $NRPRIMCFREDZ, $NRULTCFREDZ, $VRGTREDZ, $VRVENBRUREDZ, $VRISSREDZ, $VRTOTCANREDZ, $VRTOTDESREDZ, $VRVENLIQREDZ, $VRTOTACRREDZ, $IDORIGEMREDZ, $DSMODMARCAECF, $NRORG, $CDFILIAL, $CDCAIXA, $VRSTRIBREDZ, $VRISENCREDZ, $VRNINCIDREDZ, $QTTEMLIGREDZ, $QTTEMPCFREDZ, $QTMEMRESREDZ);
                $DTOBSERVREDZ = new \DateTime(null,new \DateTimeZone('America/Sao_Paulo'));
                $DTOBSERVREDZ->format("h:i:s");
                $DSOBSERVREDZ = "Reducao Z incluido as ".$DTOBSERVREDZ->format("h:i:s")." pelo operador: ".$CDOPERADOR." ".$NMOPERADOR;
                $DTOBSERVREDZ->format("d/m/Y");
                //observação
                $NRSEQOBSREDZ = $this->ManutencaoVendaService->getNRSEQOBS($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ);
                $this->ManutencaoVendaService->saveObsRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRSEQOBSREDZ, $DTOBSERVREDZ->format("d/m/Y"), $DSOBSERVREDZ);
                $response->addNotification(new Notification("Redução Z Incluida com Sucesso!", Notification::TYPE_SUCCESS));
            }
            else {
                $response->addMessage(new Message('Redução Z já incluida nesta data e ECF!'));
            }
        }
        else{
            $this->ManutencaoVendaService->editReducaoZ($DTREDUCAOZ, $NRECFREDZ, $NRREINIREDZ, $NRSERIEREDZ, $NRREDREDZ, $NRLEITREDZ, $NRGERCNFREDZ, $NRCANCFREDZ, $NRPRIMCFREDZ, $NRULTCFREDZ, $VRGTREDZ, $VRVENBRUREDZ, $VRISSREDZ, $VRTOTCANREDZ, $VRTOTDESREDZ, $VRVENLIQREDZ, $VRTOTACRREDZ, $IDORIGEMREDZ, $DSMODMARCAECF, $NRORG, $CDFILIAL, $CDCAIXA, $VRSTRIBREDZ, $VRISENCREDZ, $VRNINCIDREDZ, $QTTEMLIGREDZ, $QTTEMPCFREDZ, $QTMEMRESREDZ);
            $DTOBSERVREDZ = new \DateTime(null,new \DateTimeZone('America/Sao_Paulo'));
            $DTOBSERVREDZ->format("h:i:s");
            $DSOBSERVREDZ = "Reducao Z editada as ".$DTOBSERVREDZ->format("h:i:s")." pelo operador: ".$CDOPERADOR." ".$NMOPERADOR;
            $DTOBSERVREDZ->format("d/m/Y");
            //observação
            $NRSEQOBSREDZ = $this->ManutencaoVendaService->getNRSEQOBS($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ);
            $this->ManutencaoVendaService->saveObsRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRSEQOBSREDZ, $DTOBSERVREDZ->format("d/m/Y"), $DSOBSERVREDZ);
            $response->addNotification(new Notification("Redução Z editada com Sucesso!", Notification::TYPE_SUCCESS));
        }
    }

    public function saveImpRedz (DTO\Request $request, DTO\Response $response){
        $row = $request->getRow();

        $DTREDUCAOZ = (string)$row['DTREDUCAOZ'];
        $NRECFREDZ = (string)$row['NRECFREDZ'];
        $CDFILIAL = (string)$row['CDFILIAL'];
        $CDCAIXA = (string)$row['CDCAIXA'];
        $NRORG = (string)$row['NRORG'];
        $CDIMPOSTO = (string)$row['CDIMPOSTO'];
        $VRALIQIMPRZ = $row['VRALIQIMPRZ'];
        $VRBCALCIMPRZ = $row['VRBCALCIMPRZ'];
        $VRIMPOSTORZ = $row['VRIMPOSTORZ'];
        
        $CDOPERADOR = (string)$row['CDOPERADOR'];
        $NMOPERADOR = (string)$row['NMOPERADOR'];
        $NEW = $row['NEW'];
        $NRSEQALIQIMPRZ = $this->ManutencaoVendaService->getNRSEQALIQIMPRZ($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ, $NEW);
        
        if ($NEW){
            $this->ManutencaoVendaService->saveImpoRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $CDIMPOSTO, $VRALIQIMPRZ, $VRBCALCIMPRZ, $VRIMPOSTORZ,$NRSEQALIQIMPRZ);
            $DTOBSERVREDZ = new \DateTime(null,new \DateTimeZone('America/Sao_Paulo'));
            $DTOBSERVREDZ->format("h:i:s");
            $DSOBSERVREDZ = "Reducao Z incluido as ".$DTOBSERVREDZ->format("h:i:s")." pelo operador: ".$CDOPERADOR." ".$NMOPERADOR.". (imposto)";
            $DTOBSERVREDZ->format("d/m/Y");
            //observação
            $NRSEQOBSREDZ = $this->ManutencaoVendaService->getNRSEQOBS($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ);
            $this->ManutencaoVendaService->saveObsRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRSEQOBSREDZ, $DTOBSERVREDZ->format("d/m/Y"), $DSOBSERVREDZ);
            $response->addNotification(new Notification("Imposto Incluido com Sucesso!", Notification::TYPE_SUCCESS));
        }
        else{
            $this->ManutencaoVendaService->editaImpoRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $CDIMPOSTO, $VRALIQIMPRZ, $VRBCALCIMPRZ, $VRIMPOSTORZ, $NRSEQALIQIMPRZ);
            $DTOBSERVREDZ = new \DateTime(null,new \DateTimeZone('America/Sao_Paulo'));
            $DTOBSERVREDZ->format("h:i:s");
            $DSOBSERVREDZ = "Reducao Z editado as ".$DTOBSERVREDZ->format("h:i:s")." pelo operador: ".$CDOPERADOR." ".$NMOPERADOR.". (imposto)";
            $DTOBSERVREDZ->format("d/m/Y");
            //observação
            $NRSEQOBSREDZ = $this->ManutencaoVendaService->getNRSEQOBS($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ);
            $this->ManutencaoVendaService->saveObsRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRSEQOBSREDZ, $DTOBSERVREDZ->format("d/m/Y"), $DSOBSERVREDZ);
            $response->addNotification(new Notification("Imposto editado com Sucesso!", Notification::TYPE_SUCCESS));
        }
    }

    public function saveTotRedz (DTO\Request $request, DTO\Response $response){
        $row = $request->getRow();

        $DTREDUCAOZ = (string)$row['DTREDUCAOZ'];
        $NRECFREDZ = (string)$row['NRECFREDZ'];
        $CDFILIAL = (string)$row['CDFILIAL'];
        $CDCAIXA = (string)$row['CDCAIXA'];
        $NRORG = (string)$row['NRORG'];
        $DSTOTNFISCRZ = (string)$row['DSTOTNFISCRZ'];
        $NRCONTOTNFIS = (string)$row['NRCONTOTNFIS'];
        $VRACUTOTNFIS = str_replace(',', '.', str_replace('.', '', $row['VRACUTOTNFIS']));

        $CDOPERADOR = (string)$row['CDOPERADOR'];
        $NMOPERADOR = (string)$row['NMOPERADOR'];
        $NEW = $row['NEW'];
        $NRTOTNFISCRZ = (string)$row['NRTOTNFISCRZ'];

        if ($NEW){
            $NRTOTNFISCRZ = $this->ManutencaoVendaService->getNRTOTNFISCRZ($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ);
            $this->ManutencaoVendaService->saveTotRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRTOTNFISCRZ, $DSTOTNFISCRZ, $NRCONTOTNFIS, $VRACUTOTNFIS);
            $DTOBSERVREDZ = new \DateTime(null,new \DateTimeZone('America/Sao_Paulo'));
            $DTOBSERVREDZ->format("h:i:s");
            $DSOBSERVREDZ = "Reducao Z incluido as ".$DTOBSERVREDZ->format("h:i:s")." pelo operador: ".$CDOPERADOR." ".$NMOPERADOR.". (Totalizador)";
            $DTOBSERVREDZ->format("d/m/Y");
            //observação
            $NRSEQOBSREDZ = $this->ManutencaoVendaService->getNRSEQOBS($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ);
            $this->ManutencaoVendaService->saveObsRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRSEQOBSREDZ, $DTOBSERVREDZ->format("d/m/Y"), $DSOBSERVREDZ);
            $response->addNotification(new Notification("Totalizador Incluido com Sucesso!", Notification::TYPE_SUCCESS));
        }
        else{
            $this->ManutencaoVendaService->editaTotRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRTOTNFISCRZ, $DSTOTNFISCRZ, $NRCONTOTNFIS, $VRACUTOTNFIS);
            $DTOBSERVREDZ = new \DateTime(null,new \DateTimeZone('America/Sao_Paulo'));
            $DTOBSERVREDZ->format("h:i:s");
            $DSOBSERVREDZ = "Reducao Z editado as ".$DTOBSERVREDZ->format("h:i:s")." pelo operador: ".$CDOPERADOR." ".$NMOPERADOR.". (Totalizador)";
            $DTOBSERVREDZ->format("d/m/Y");
            //observação
            $NRSEQOBSREDZ = $this->ManutencaoVendaService->getNRSEQOBS($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ);
            $this->ManutencaoVendaService->saveObsRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRSEQOBSREDZ, $DTOBSERVREDZ->format("d/m/Y"), $DSOBSERVREDZ);
            $response->addNotification(new Notification("Totalizador editado com Sucesso!", Notification::TYPE_SUCCESS));
        }
    }

    public function savePaymentRedz (DTO\Request $request, DTO\Response $response){
        $row = $request->getRow();

        $DTREDUCAOZ = (string)$row['DTREDUCAOZ'];
        $NRECFREDZ = (string)$row['NRECFREDZ'];
        $CDFILIAL = (string)$row['CDFILIAL'];
        $CDCAIXA = (string)$row['CDCAIXA'];
        $NRORG = (string)$row['NRORG'];
        $CDTIPORECE = (string)$row['CDTIPORECE'];
        $VRFORMPGTORZ = str_replace(',', '.', str_replace('.', '', $row['VRFORMPGTORZ']));
        $CDTPRECEORIG = (string)$row['CDTPRECEORIG'];
        $NEW = $row['NEW'];
        $CDOPERADOR = (string)$row['CDOPERADOR'];
        $NMOPERADOR = (string)$row['NMOPERADOR'];
        
        if($NEW) {
            $VERIFY = $this->ManutencaoVendaService->verifyTiporece($CDFILIAL, $CDCAIXA, $DTREDUCAOZ, $NRECFREDZ, $CDTIPORECE);
            if(empty($VERIFY)) {
                $this->ManutencaoVendaService->savePaymentRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $CDTIPORECE, $VRFORMPGTORZ, $CDTPRECEORIG);
                $DTOBSERVREDZ = new \DateTime(null,new \DateTimeZone('America/Sao_Paulo'));
                $DTOBSERVREDZ->format("h:i:s");
                $DSOBSERVREDZ = "Reducao Z incluido as ".$DTOBSERVREDZ->format("h:i:s")." pelo operador: ".$CDOPERADOR." ".$NMOPERADOR.". (Recebimento)";
                $DTOBSERVREDZ->format("d/m/Y");
                //observação
                $NRSEQOBSREDZ = $this->ManutencaoVendaService->getNRSEQOBS($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ);
                $this->ManutencaoVendaService->saveObsRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRSEQOBSREDZ, $DTOBSERVREDZ->format("d/m/Y"), $DSOBSERVREDZ);
                $response->addNotification(new Notification("Recebimento Incluido com Sucesso!", Notification::TYPE_SUCCESS));
            }
            else{
                 $response->addMessage(new Message('Atenção tipo de recebimento ja cadastrado!'));
            }
        }
        else{
            $this->ManutencaoVendaService->editaPaymentRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $CDTIPORECE, $VRFORMPGTORZ, $CDTPRECEORIG);
            $DTOBSERVREDZ = new \DateTime(null,new \DateTimeZone('America/Sao_Paulo'));
            $DTOBSERVREDZ->format("h:i:s");
            $DSOBSERVREDZ = "Reducao Z editado as ".$DTOBSERVREDZ->format("h:i:s")." pelo operador: ".$CDOPERADOR." ".$NMOPERADOR.". (Recebimento)";
            $DTOBSERVREDZ->format("d/m/Y");
            //observação
            $NRSEQOBSREDZ = $this->ManutencaoVendaService->getNRSEQOBS($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ);
            $this->ManutencaoVendaService->saveObsRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRSEQOBSREDZ, $DTOBSERVREDZ->format("d/m/Y"), $DSOBSERVREDZ);
            $response->addNotification(new Notification("Recebimento edita com Sucesso!", Notification::TYPE_SUCCESS)); 
        }
    }

    public function saveObsRedz (DTO\Request $request, DTO\Response $response){
        try {
            $row = $request->getRow();

            $DTREDUCAOZ = (string)$row['DTREDUCAOZ'];
            $NRECFREDZ = (string)$row['NRECFREDZ'];
            $CDFILIAL = (string)$row['CDFILIAL'];
            $CDCAIXA = (string)$row['CDCAIXA'];
            $NRORG = (string)$row['NRORG'];
            $DTOBSERVREDZ = (string)$row['DTOBSERVREDZ'];
            $DSOBSERVREDZ = (string)$row['DSOBSERVREDZ'];
            
            $NRSEQOBSREDZ = $this->ManutencaoVendaService->getNRSEQOBS($CDFILIAL, $CDCAIXA, $NRECFREDZ, $DTREDUCAOZ);
            try {
                $this->ManutencaoVendaService->saveObsRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG, $NRSEQOBSREDZ, $DTOBSERVREDZ, $DSOBSERVREDZ);
            } catch (Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));        
            }
            $response->addNotification(new Notification("Observação Incluida com Sucesso!", Notification::TYPE_SUCCESS));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function deleteRedz(DTO\Request $request, DTO\Response $response){
        $row = $request->getRow();
        $DTREDUCAOZ  = $row['DTREDUCAOZ'];
        $NRECFREDZ   = $row['NRECFREDZ'];
        $CDFILIAL    = $row['CDFILIAL'];
        $CDCAIXA     = $row['CDCAIXA'];
        $NRORG       = $row['NRORG'];

        $this->ManutencaoVendaService->deleteCascadeRedz($DTREDUCAOZ, $NRECFREDZ, $CDFILIAL, $CDCAIXA, $NRORG);
        $this->dataSourceName = "vnd02600_manutencaodavenda_reducaoz";
        parent::delete($request,$response);
    }
    
    public function deleteImposto(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = "vnd02600_manutencaodavenda_reducaoz_imposto";
        parent::delete($request,$response);
    }

    public function deleteTotalizadores(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = "vnd02600_manutencaodavenda_reducaoz_totalizadores";
        parent::delete($request,$response);
    }

    public function deleteRecebimentos(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = "vnd02600_manutencaodavenda_reducaoz_formas";
        parent::delete($request,$response);
    }
    
    public function findProductsItem(DTO\Request\Filter $request, DTO\Response $response){
       $dataTabPrec = [];
       $rows = $this->util->getParamsAsArray($request);
       
       $likeableConditions = $this->util->getLikeConditions($request);
        foreach ($likeableConditions as $condition) {
			if(Functions::arrayKeyExists($condition['columnName'], $rows)) {
				 unset($rows[$condition['columnName']]);
			}
			if(Functions::arrayKeyExists(('T'.$condition['columnName']), $rows)){
			    $rows['T'.$condition['columnName']] =  NULL;
			}
		}
       if($rows['CDFILIAL'] != ''){
               $grupo = $this->ManutencaoVendaService->checkProdutGroup($rows['CDFILIAL'], $rows['NRORG']);
               if(isset($grupo[0]['CDGRPRODPDV'])){
                   $paramsGroup['CDFILIAL'] = $rows['CDFILIAL'];
                   $paramsGroup['NRORG'] = $rows['NRORG'];
                   $this->dataSourceName = 'vnd02600_manutencaodavenda_grupo_produto';
                   $newRequest = $this->util->createNewZeedhiFilterRequestObject($request, 'vnd02600_manutencaodavenda_grupo_produto', $paramsGroup);
                    foreach ($likeableConditions as $condition) {
                        $newRequest->getFilterCriteria()->addCondition($condition['columnName'], $condition['operator'], $condition['value']);
                	}
                    $this->parameterBagColumns = array('NRORG', 'CDFILIAL');
                    parent::find($newRequest,$response);
                    $produtoGrupo = $response->getDataSets()[0]->getRows();
                   
                   $tabPrec = $this->ManutencaoVendaService->checkTabelaPreco($rows['CDFILIAL'], $rows['NRORG'], $rows['CDCLIENTE'], $rows['CDLOJA']);
                   if(count($produtoGrupo) == 0){
                         $response->addMessage(new Message("Não há produto cadastrado para o agrupamento da filial.", Message::TYPE_ERROR));
                   } else {
                       $tabPrec = $this->ManutencaoVendaService->checkTabelaPreco($rows['CDFILIAL'], $rows['NRORG'], $rows['CDCLIENTE'], $rows['CDLOJA']);
                       $dataTabPrec['CDTABEPREC'] = $tabPrec[0];
                       $dataTabPrec['CDFILTABPREC'] = $tabPrec[1];
                       $dataTabPrec['DTINIVGPREC'] = $tabPrec[2][0]['DTINIVGPREC'];
                       $produtoGrupo[0][1] = $dataTabPrec;
                       $response->addDataSet(new DataSet('vnd02600_manutencaodavenda_grupo_produto', $produtoGrupo));
                   }
               } else if(!(isset($rows['IsCancelados']))){ // ITENS
                   $tabPrec = $this->ManutencaoVendaService->checkTabelaPreco($rows['CDFILIAL'], $rows['NRORG'], $rows['CDCLIENTE'], $rows['CDLOJA']);
                   
                   if(!$tabPrec){
                      $response->addMessage(new Message("Não há tabela de preço vigente ou parametrizada", Message::TYPE_ERROR));  
                   } else {
                       $this->dataSourceName = "vnd02600_manutencaodavenda_select_itens";
                       $newRequest = $this->util->createNewZeedhiFilterRequestObject($request, $this->dataSourceName, $rows);
                      foreach ($likeableConditions as $condition) {
                                $newRequest->getFilterCriteria()->addCondition($condition['columnName'], $condition['operator'], $condition['value']);
                		}
                       $this->parameterBagColumns = array('NRORG', 'CDFILIAL', 'CDLOJA', 'CDCLIENTE');
                       parent::find($newRequest,$response);
                       $arrayResponse = $response->getDataSets()[0]->getRows();
                       if(count($arrayResponse) == 0 && !$likeableConditions){
                         $response->addMessage(new Message("Verifique se os produtos da Tabela de Preço possuem imposto.", Message::TYPE_ERROR));
                        }
                       $dataTabPrec['CDTABEPREC'] = $tabPrec[0];
                       $dataTabPrec['CDFILTABPREC'] = $tabPrec[1];
                       $dataTabPrec['DTINIVGPREC'] = $tabPrec[2][0]['DTINIVGPREC'];
                       
                       $arrayResponse[0][1] = $dataTabPrec;
                       $response->addDataSet(new DataSet($this->dataSourceName, $arrayResponse));
                   }
               }
            else { // ITENS CANCELADOS
                $this->dataSourceName = 'vnd02600_manutencaodavenda_select_itens_cancelados';
                $newRequest = $this->util->createNewZeedhiFilterRequestObject($request, $this->dataSourceName, $rows);
                foreach ($likeableConditions as $condition) {
                        $newRequest->getFilterCriteria()->addCondition($condition['columnName'], $condition['operator'], $condition['value']);
        		}
        		
                $arrayResponse = $this->ManutencaoVendaService->findItensCancelados($rows);
                $tabPrec = $this->ManutencaoVendaService->checkTabelaPreco($rows['CDFILIAL'], $rows['NRORG'], $rows['CDCLIENTE'], $rows['CDLOJA']);
                
                if($tabPrec){
                       $dataTabPrec['CDTABEPREC'] = $tabPrec[0];
                       $dataTabPrec['CDFILTABPREC'] = $tabPrec[1];
                       $dataTabPrec['DTINIVGPREC'] = $tabPrec[2][0]['DTINIVGPREC'];
                   } else {
                       $dataTabPrec['CDTABEPREC'] = null;
                       $dataTabPrec['CDFILTABPREC'] = null;
                       $dataTabPrec['DTINIVGPREC'] = null;
                   }
                if(count($arrayResponse) > 0)    
                    $arrayResponse[0][1] = $dataTabPrec;
                    
                $response->addDataSet(new DataSet($this->dataSourceName, $arrayResponse));   
                
           }
       }
    }     
    
    public function deleteItens(DTO\Request $request, DTO\Response $response){
        $row = $request->getRow();
        $CDFILIAL       = $row['CDFILIAL'];
        $NRSEQVENDA     = $row['NRSEQVENDA'];
        $NRSEQUITVEND   = $row['NRSEQUITVEND'];
        $NRSEQITIMPOS   = $row['NRSEQITIMPOS'];
        $CAIXA          = $row['CDCAIXA'];
        $NRORG          = $row['NRORG'];

        return $this->ManutencaoVendaService->deleteItens($CDFILIAL, $NRSEQVENDA, $NRSEQUITVEND, $NRSEQITIMPOS, $CAIXA, $NRORG);
    }
    
    public function deleteItensCan(DTO\Request $request, DTO\Response $response){
        $row = $request->getRow();
        $CDFILIAL       = $row['CDFILIAL'];
        $NRSEQVENDA     = $row['NRSEQVENDA'];
        $NRSEQITVENDC   = $row['NRSEQITVENDC'];
        $CAIXA          = $row['CDCAIXA'];
        $NRORG          = $row['NRORG'];

        return $this->ManutencaoVendaService->deleteItensCan($CDFILIAL, $NRSEQVENDA, $NRSEQITVENDC, $CAIXA, $NRORG);
    }
    
    public function deleteRecebimentoItem(DTO\Request $request, DTO\Response $response){
        $row = $request->getRow();
        $CDFILIAL       = $row['CDFILIAL'];
        $DTABERCAIX     = $row['DTABERCAIX'];
        $NRSEQUMOVI     = $row['NRSEQUMOVI'];
        $CAIXA          = $row['CDCAIXA'];
        $NRORG          = $row['NRORG'];
        return $this->ManutencaoVendaService->deleteRecebimentoItem($CDFILIAL, $DTABERCAIX, $NRSEQUMOVI, $CAIXA, $NRORG);
    }
    
    public function tabPrecProd(DTO\Request\Row $request,DTO\Response $response){
	    $param = $request->getRow();
	    $preço = $this->ManutencaoVendaService->getTabPrecProd($param['NRORG'], $param['CDFILTABPREC'], $param['CDTABPREC'], $param['CDPRODUTO'], $param['DATAINCLUSAO']);
	    $response->addDataSet(new DataSet("getTabPrecProd", $preço));
	}
	
	public function selectConsumidor(DTO\Request $request, DTO\Response $response){
	    $row = $request->getFilterCriteria()->getConditions();
	    $data = $this->ManutencaoVendaService->selectConsumidor($row[0]['value'], $row[1]['value']);
	    $response->addDataSet(new DataSet("select_consumidor_manutencaoVenda", $data));
	}
	
	public function selectServico(DTO\Request $request, DTO\Response $response){
	    $row = $request->getFilterCriteria()->getConditions();
	    $data = $this->ManutencaoVendaService->selectServico($row[0]['value'], $row[1]['value']);
	    $response->addDataSet(new DataSet("select_servico_manutencaoVenda", $data));
	}
}