<?php 

namespace Teknisa\MAN\Controllers;

use Teknisa\MAN\Services\ParamsProduto as ParamsProdutoService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class ParamsProduto {
    
    protected $paramsProdutoService;
    
    public function __construct(ParamsProdutoService $paramsProdutoService){
        $this->paramsProdutoService = $paramsProdutoService;
    } 
    
    public function getCDNVPRODUTO(DTO\Request\Row $request, DTO\Response $response) {
        
        try {
            $row = $request->getRow();
            $NRORG =  $row['NRORG'];
            $result = $this->paramsProdutoService->getCDNVPRODUTO($NRORG);
            $response->addDataSet(new DataSet('produto', $result));
            
        } catch (Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}